/************************************************************************
*                                                                       *
*   NUIHeadPosition.h                                                   *
*   Copyright (c) Microsoft Corp. All rights reserved.                  *
*                                                                       *
************************************************************************/

#pragma once



#ifndef NUIAPI
#error "You must include nuiapi.h rather than including NuiHeadPosition.h directly"
#endif



#ifdef __cplusplus
extern "C" {
#endif



#define NUI_HEAD_POSITION_COUNT 16

#define NUI_HEAD_POSITION_FLAG_SUPPRESS_NO_FRAME_DATA   0x00000001

#define NUI_HEAD_POSITION_QUALITY_LOST  0x00000010

typedef struct _NUI_HEAD_POSITION_DATA
{
    DWORD    TrackingID;     // When this is 0, there is no tracked head for this slot.
    DWORD    QualityFlags;
    DWORD    Rank;           // Value from 1 to NUI_HEAD_COUNT (16) where 1 is the most probable head.  Non-tracked slots, this will be 0.
    DWORD    Reserved;
    XMVECTOR Position;
    RECT     Bounds;
} NUI_HEAD_POSITION_DATA;


typedef struct _NUI_HEAD_POSITION_FRAME
{
    UINT64   TimeStamp;
    DWORD    FrameNumber;
    DWORD    Reserved;
    NUI_HEAD_POSITION_DATA HeadPositionData[NUI_HEAD_POSITION_COUNT];
} NUI_HEAD_POSITION_FRAME;


NUIAPI
HRESULT
NuiHeadPositionEnable(
    _In_opt_ HANDLE hNextFrameEvent,
    _In_     DWORD Flags
    );


NUIAPI
HRESULT
NuiHeadPositionDisable(
    );


NUIAPI
HRESULT
NuiHeadPositionGetNextFrame(
    _In_    DWORD MillisecondsToWait,
    _Out_   NUI_HEAD_POSITION_FRAME *pHeadPositionFrame
    );



#ifdef __cplusplus
} //close extern "C"
#endif

