/************************************************************************
*                                                                       *
*   NuiWave.h -- This module defines the Kinect Wave gesture            *
*                recognizer API                                         *
*                                                                       *
*   Copyright (c) Microsoft Corp. All rights reserved.                  *
*                                                                       *
************************************************************************/

#pragma once

#ifndef _NUI_WAVE_H_
#define _NUI_WAVE_H_

#ifdef __cplusplus
extern "C" {
#endif

typedef struct _NUI_WAVE_PLAYER_STATE
{
    FLOAT    fLeftHandWaveProgress;
    BOOL     bLeftHandLastMotionToLeft;
    
    FLOAT    fRightHandWaveProgress;
    BOOL     bRightHandLastMotionToLeft;

    DWORD    dwTrackingID;
} NUI_WAVE_PLAYER_STATE, *PNUI_WAVE_PLAYER_STATE;
typedef const NUI_WAVE_PLAYER_STATE *PCNUI_WAVE_PLAYER_STATE;

typedef struct _NUI_WAVE_STATE_
{
    NUI_WAVE_PLAYER_STATE   aPlayers[NUI_SKELETON_MAX_TRACKED_COUNT];
} NUI_WAVE_STATE, *PNUI_WAVE_STATE;
typedef const NUI_WAVE_STATE *PCNUI_WAVE_STATE;

XBOXAPI
HRESULT
NuiWaveSetEnabled(__in      BOOL                bEnabled);

XBOXAPI
HRESULT
NuiWaveGetState(__out       PNUI_WAVE_STATE     pState);

XBOXAPI 
HRESULT 
NuiWaveGetGestureOwnerProgress( __out  PDWORD  pdwTrackingID, 
                                 __out  PFLOAT  pfWaveProgress );


#ifdef __cplusplus
}
#endif

#endif  //_NUI_WAVE include
