/***
*conio.h - console and port I/O declarations
*
*       Copyright (c) Microsoft Corporation. All rights reserved.
*
*Purpose:
*       This include file contains the function declarations for
*       the MS C V2.03 compatible console I/O routines.
*
*       [Public]
*
****/

#pragma once

#ifndef _INC_CONIO
#define _INC_CONIO

#include <crtdefs.h>

#ifndef _XBSTRICT

#ifdef __cplusplus
extern "C" {
#endif

/* Function prototypes */

_Check_return_wat_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cgets_s) errno_t __cdecl _cgets_s(_Out_z_cap_(_Size)                char * _Buffer, size_t _Size, _Out_ size_t * _SizeRead);
#if defined(__cplusplus)
_XBOX_CRT_UNSUPPORTED(_cgets_s)
#endif
__DEFINE_CPP_OVERLOAD_SECURE_FUNC_0_1(errno_t, _cgets_s, _Deref_post_count_(*_Buffer) char, _Buffer, _Out_ size_t *, _SizeRead)
__DEFINE_CPP_OVERLOAD_STANDARD_FUNC_0_0_CGETS(char *, _CRTIMP, _cgets, _Pre_notnull_ _Post_z_, char, _Buffer)
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cprintf) int __cdecl _cprintf(_In_z_ _Printf_format_string_ const char * _Format, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cprintf_s) int __cdecl _cprintf_s(_In_z_ _Printf_format_string_ const char * _Format, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cputs) int __cdecl _cputs(_In_z_ const char * _Str);
_XBOX_CRT_UNSUPPORTED_INSECURE(_cscanf, _cscanf_s)
_Check_return_opt_ _CRT_INSECURE_DEPRECATE(_cscanf_s) _CRTIMP int __cdecl _cscanf(_In_z_ _Scanf_format_string_ const char * _Format, ...);
_XBOX_CRT_UNSUPPORTED_INSECURE(_cscanf_l, _cscanf_s_l)
_Check_return_opt_ _CRT_INSECURE_DEPRECATE(_cscanf_s_l) _CRTIMP int __cdecl _cscanf_l(_In_z_ _Scanf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cscanf_s) int __cdecl _cscanf_s(_In_z_ _Scanf_format_string_ const char * _Format, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cscanf_s_l) int __cdecl _cscanf_s_l(_In_z_ _Scanf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, ...);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getch) int __cdecl _getch(void);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getche) int __cdecl _getche(void);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcprintf) int __cdecl _vcprintf(_In_z_ _Printf_format_string_ const char * _Format, va_list _ArgList);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcprintf_s) int __cdecl _vcprintf_s(_In_z_ _Printf_format_string_ const char * _Format, va_list _ArgList);

_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cprintf_p) int __cdecl _cprintf_p(_In_z_ _Printf_format_string_ const char * _Format, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcprintf_p) int __cdecl _vcprintf_p(_In_z_ const char * _Format, va_list _ArgList);

_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cprintf_l) int __cdecl _cprintf_l(_In_z_ _Printf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cprintf_s_l) int __cdecl _cprintf_s_l(_In_z_ _Printf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcprintf_l) int __cdecl _vcprintf_l(_In_z_ _Printf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, va_list _ArgList);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcprintf_s_l) int __cdecl _vcprintf_s_l(_In_z_ _Printf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, va_list _ArgList);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cprintf_p_l) int __cdecl _cprintf_p_l(_In_z_ _Printf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcprintf_p_l) int __cdecl _vcprintf_p_l(_In_z_ _Printf_format_string_ const char * _Format, _In_opt_ _locale_t _Locale, va_list _ArgList);

_XBOX_CRT_UNSUPPORTED(_kbhit)
_CRTIMP int __cdecl _kbhit(void);
_XBOX_CRT_UNSUPPORTED(_putch)
_CRTIMP int __cdecl _putch(_In_ int _Ch);
_XBOX_CRT_UNSUPPORTED(_ungetch)
_CRTIMP int __cdecl _ungetch(_In_ int _Ch);

_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getch_nolock) int __cdecl _getch_nolock(void);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getche_nolock) int __cdecl _getche_nolock(void);
_XBOX_CRT_UNSUPPORTED(_putch_nolock)
_CRTIMP int __cdecl _putch_nolock(_In_ int _Ch);
_XBOX_CRT_UNSUPPORTED(_ungetch_nolock)
_CRTIMP int __cdecl _ungetch_nolock(_In_ int _Ch);

#ifndef _WCONIO_DEFINED

/* wide function prototypes, also declared in wchar.h */

#ifndef WEOF
#define WEOF (wint_t)(0xFFFF)
#endif

_Check_return_wat_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cgetws_s) errno_t __cdecl _cgetws_s(_Out_cap_post_count_(_SizeInWords, *_SizeRead) wchar_t * _Buffer, size_t _SizeInWords, _Out_ size_t * _SizeRead);
#if defined(__cplusplus)
_XBOX_CRT_UNSUPPORTED(_cgetws_s)
#endif
__DEFINE_CPP_OVERLOAD_SECURE_FUNC_0_1(errno_t, _cgetws_s, _Deref_post_count_(*_Buffer) wchar_t, _Buffer, size_t *, _SizeRead)
__DEFINE_CPP_OVERLOAD_STANDARD_FUNC_0_0_CGETS(wchar_t *, _CRTIMP, _cgetws, _Pre_notnull_ _Post_z_, wchar_t, _Buffer)
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getwch) wint_t __cdecl _getwch(void);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getwche) wint_t __cdecl _getwche(void);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_putwch) wint_t __cdecl _putwch(wchar_t _WCh);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_ungetwch) wint_t __cdecl _ungetwch(wint_t _WCh);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cputws) int __cdecl _cputws(_In_z_ const wchar_t * _String);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cwprintf) int __cdecl _cwprintf(_In_z_ _Printf_format_string_ const wchar_t * _Format, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cwprintf_s) int __cdecl _cwprintf_s(_In_z_ _Printf_format_string_ const wchar_t * _Format, ...);
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_INSECURE(_cwscanf, _cwscanf_s) _CRTIMP int __cdecl _cwscanf(_In_z_ _Scanf_format_string_ const wchar_t * _Format, ...);
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_INSECURE(_cwscanf_l, _cwscanf_s_l) _CRTIMP int __cdecl _cwscanf_l(_In_z_ _Scanf_format_string_ const wchar_t * _Format, _In_opt_ _locale_t _Locale, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cwscanf_s) int __cdecl _cwscanf_s(_In_z_ _Scanf_format_string_ const wchar_t * _Format, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cwscanf_s_l) int __cdecl _cwscanf_s_l(_In_z_ _Scanf_format_string_ const wchar_t * _Format, _In_opt_ _locale_t _Locale, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcwprintf) int __cdecl _vcwprintf(_In_z_ _Printf_format_string_ const wchar_t *_Format, va_list _ArgList);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcwprintf_s) int __cdecl _vcwprintf_s(_In_z_ _Printf_format_string_ const wchar_t *_Format, va_list _ArgList);

_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_cwprintf_p) int __cdecl _cwprintf_p(_In_z_ _Printf_format_string_ const wchar_t * _Format, ...);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_vcwprintf_p) int __cdecl _vcwprintf_p(_In_z_ _Printf_format_string_ const wchar_t*  _Format, va_list _ArgList);

_XBOX_CRT_UNSUPPORTED(_cwprintf_l)
_CRTIMP int __cdecl _cwprintf_l(_In_z_ _Printf_format_string_ const wchar_t * _Format, _In_opt_ _locale_t _Locale, ...);
_XBOX_CRT_UNSUPPORTED(_cwprintf_s_l)
_CRTIMP int __cdecl _cwprintf_s_l(_In_z_ _Printf_format_string_ const wchar_t * _Format, _In_opt_ _locale_t _Locale, ...);
_XBOX_CRT_UNSUPPORTED(_vcwprintf_l)
_CRTIMP int __cdecl _vcwprintf_l(_In_z_ _Printf_format_string_ const wchar_t *_Format, _In_opt_ _locale_t _Locale, va_list _ArgList);
_XBOX_CRT_UNSUPPORTED(_vcwprintf_s_l)
_CRTIMP int __cdecl _vcwprintf_s_l(_In_z_ _Printf_format_string_ const wchar_t * _Format, _In_opt_ _locale_t _Locale, va_list _ArgList);
_XBOX_CRT_UNSUPPORTED(_cwprintf_p_l)
_CRTIMP int __cdecl _cwprintf_p_l(_In_z_ _Printf_format_string_ const wchar_t * _Format, _In_opt_ _locale_t _Locale, ...);
_XBOX_CRT_UNSUPPORTED(_vcwprintf_p_l)
_CRTIMP int __cdecl _vcwprintf_p_l(_In_z_ _Printf_format_string_ const wchar_t * _Format, _In_opt_ _locale_t _Locale, va_list _ArgList);

_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_putwch_nolock) wint_t __cdecl _putwch_nolock(wchar_t _WCh);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getwch_nolock) wint_t __cdecl _getwch_nolock(void);
_Check_return_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_getwche_nolock) wint_t __cdecl _getwche_nolock(void);
_Check_return_opt_ _CRTIMP _XBOX_CRT_UNSUPPORTED(_ungetwch_nolock) wint_t __cdecl _ungetwch_nolock(wint_t _WCh);

#define _WCONIO_DEFINED
#endif  /* _WCONIO_DEFINED */

#if     !__STDC__

/* Non-ANSI names for compatibility */

#pragma warning(push)
#pragma warning(disable: 4141) /* Using deprecated twice */ 
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_NONSTDC_INSECURE(cgets, _cgets, _cgets_s) _CRT_INSECURE_DEPRECATE(_cgets_s) _CRTIMP char * __cdecl cgets(_Out_z_cap_x_(*_Buffer+2) char * _Buffer);
#pragma warning(pop)
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_NONSTDC(cprintf, _cprintf) _CRTIMP int __cdecl cprintf(_In_z_ _Printf_format_string_ const char * _Format, ...);
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_NONSTDC(cputs, _cputs) _CRTIMP int __cdecl cputs(_In_z_ const char * _Str);
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_NONSTDC(cscanf, _cscanf) _CRTIMP int __cdecl cscanf(_In_z_ _Scanf_format_string_ const char * _Format, ...);
_Check_return_ _XBOX_CRT_UNSUPPORTED_NONSTDC(getch, _getch) _CRTIMP int __cdecl getch(void);
_Check_return_ _XBOX_CRT_UNSUPPORTED_NONSTDC(getche, _getche) _CRTIMP int __cdecl getche(void);
_Check_return_ _XBOX_CRT_UNSUPPORTED_NONSTDC(kbhit, _kbhit) _CRTIMP int __cdecl kbhit(void);
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_NONSTDC(putch, _putch) _CRTIMP int __cdecl putch(int _Ch);
_Check_return_opt_ _XBOX_CRT_UNSUPPORTED_NONSTDC(ungetch, _ungetch) _CRTIMP int __cdecl ungetch(int _Ch);

#endif  /* __STDC__ */

#ifdef  __cplusplus
}
#endif

#endif // XBSTRICT

#endif  /* _INC_CONIO */
