/**************************************************************************
 * 
 * Copyright (c) Microsoft Corporation.  All rights reserved.
 * 
 * Module Name:
 * 
 *     pmcPB.h
 * 
 * Abstract:
 * 
 *     API for CPU performance counters.
 *     
 *     The original LibPMCPB APIs have been deprecated and replaced by
 *     their new counter parts in xbdm.h usually starting with Dm and the
 *     original name. Please refer to the XDK documentation.
 *     The new library in xbdm is multi user safe and prevents
 *     a counter session from being inadvertly stomped on by another
 *     user or the performance tools.
 *
 *************************************************************************/

#ifndef __PMCPB_H__
#define __PMCPB_H__

#ifdef __cplusplus
extern "C"{
#endif

////////////////////////////////////////////////////////////////////
//
// Redirect to new multi user PMCPB functions in xbdm
//

#include <xbdm.h>

#define PMCResetCounters            DmPMCResetCounters
#define PMCSetTriggerProcessor      DmPMCSetTriggerProcessor
#define PMCStart                    DmPMCStart
#define PMCStop                     DmPMCStop
#define PMCGetCounter               DmPMCGetSingleCounter
#define PMCGetCounters              DmPMCGetCounters
#define PMCGetCounterName           DmPMCGetCounterName
#define PMCDumpCounters             DmPMCDumpCounters
#define PMCDumpCountersVerbose      DmPMCDumpCountersVerbose
#define PMCGetCounterCostEstimate   DmPMCGetCounterCostEstimate
#define PMCGetCounterSource         DmPMCGetCounterSource
#define PMCComputeFrequency         DmPMCComputeFrequency

#ifdef __cplusplus
}
#endif

#endif
