/**************************************************************************
 *
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * 
 * Module Name:
 * 
 *     pmcPBSetup.h
 * 
 * Abstract:
 * 
 *     Setup API for CPU performance counters.
 * 
 *     void main()
 *     {
 *         DmPMCInstallAndStart( PMC_SETUP_OVERVIEW );    
 *         ... code to profile ...
 *         DmPMCStopAndReport();
 *     }
 * 
 *     The original LibPMCPB APIs have been deprecated and replaced by
 *     their new counter parts in xbdm.h usually starting with Dm and the
 *     original name. Please refer to the XDK documentation.
 *     The new library in xbdm is multi user safe and prevents
 *     a counter session from being inadvertly stomped on by another
 *     user or the performance tools.
 * 
 *************************************************************************/

#ifndef __PMCPBSETUP_H__
#define __PMCPBSETUP_H__

#ifdef __cplusplus
extern "C"{
#endif

__declspec(deprecated("PMCInstallSetupOnThisCore has been deprecated. \
                       Use DMHRAPI DmPMCInstallSetup( ePMCSetup whichSetup ) from xbdm.h instead. \
                       This function should be paired with VOID DmPMCUnInstallSetup( VOID )."))
                       VOID PMCInstallSetupOnThisCore( VOID );

////////////////////////////////////////////////////////////////////
//
// Redirect to new multi user PMCPB functions in xbdm
//
#include <xbdm.h>
#define PMCInstallAndStart      DmPMCInstallAndStart
#define PMCStopAndReport        DmPMCStopAndReport
#define PMCInstallSetup         DmPMCInstallSetup
#define PMCUnInstallSetup       DmPMCUnInstallSetup


#ifdef __cplusplus
}
#endif

#endif
