
/***************************************************************************
 *
 *  XAvatarTypes.h
 *
 *  This module defines the common Xbox Avatar types
 *
 *  Copyright (C) Microsoft Corporation.  All Rights Reserved.
 *
 ***************************************************************************/

#ifndef _XAVATARTYPES_H_
#define _XAVATARTYPES_H_

#pragma once

#ifdef __cplusplus
extern "C" {
#endif

//
// Metadata structure.  This opaque byte array is used by the avatar system
// to describe everything about an avatar including body size/shape, facial
// features, clothing, etc.
//
typedef struct _XAVATAR_METADATA
{
    BYTE                                    Reserved[ 1000 ];

} XAVATAR_METADATA, *PXAVATAR_METADATA;

//
// Asset identifier.
//
typedef GUID XAVATAR_ASSET_ID;

#ifdef __cplusplus
}
#endif

#endif // _XAVATARTYPES_H_
